/**
 * @name json-variables
 * @fileoverview Resolves custom-marked, cross-referenced paths in parsed JSON
 * @version 12.0.13
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/json-variables/}
 */

"use strict";var jsonVariables=(()=>{var Re=Object.create;var M=Object.defineProperty,Ve=Object.defineProperties,Ce=Object.getOwnPropertyDescriptor,Me=Object.getOwnPropertyDescriptors,He=Object.getOwnPropertyNames,se=Object.getOwnPropertySymbols,je=Object.getPrototypeOf,ae=Object.prototype.hasOwnProperty,Be=Object.prototype.propertyIsEnumerable;var G=(e,r,n)=>r in e?M(e,r,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[r]=n,v=(e,r)=>{for(var n in r||(r={}))ae.call(r,n)&&G(e,n,r[n]);if(se)for(var n of se(r))Be.call(r,n)&&G(e,n,r[n]);return e},H=(e,r)=>Ve(e,Me(r));var oe=(e,r)=>()=>(r||e((r={exports:{}}).exports,r),r.exports),Pe=(e,r)=>{for(var n in r)M(e,n,{get:r[n],enumerable:!0})},le=(e,r,n,a)=>{if(r&&typeof r=="object"||typeof r=="function")for(let l of He(r))!ae.call(e,l)&&l!==n&&M(e,l,{get:()=>r[l],enumerable:!(a=Ce(r,l))||a.enumerable});return e};var J=(e,r,n)=>(n=e!=null?Re(je(e)):{},le(r||!e||!e.__esModule?M(n,"default",{value:e,enumerable:!0}):n,e)),Je=e=>le(M({},"__esModule",{value:!0}),e);var Q=(e,r,n)=>(G(e,typeof r!="symbol"?r+"":r,n),n);var F=oe((hr,fe)=>{"use strict";fe.exports=Fe;function x(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function Fe(e){if(e=e||{},e.circles)return Le(e);return e.proto?a:n;function r(l,t){for(var o=Object.keys(l),s=new Array(o.length),u=0;u<o.length;u++){var i=o[u],g=l[i];typeof g!="object"||g===null?s[i]=g:g instanceof Date?s[i]=new Date(g):ArrayBuffer.isView(g)?s[i]=x(g):s[i]=t(g)}return s}function n(l){if(typeof l!="object"||l===null)return l;if(l instanceof Date)return new Date(l);if(Array.isArray(l))return r(l,n);if(l instanceof Map)return new Map(r(Array.from(l),n));if(l instanceof Set)return new Set(r(Array.from(l),n));var t={};for(var o in l)if(Object.hasOwnProperty.call(l,o)!==!1){var s=l[o];typeof s!="object"||s===null?t[o]=s:s instanceof Date?t[o]=new Date(s):s instanceof Map?t[o]=new Map(r(Array.from(s),n)):s instanceof Set?t[o]=new Set(r(Array.from(s),n)):ArrayBuffer.isView(s)?t[o]=x(s):t[o]=n(s)}return t}function a(l){if(typeof l!="object"||l===null)return l;if(l instanceof Date)return new Date(l);if(Array.isArray(l))return r(l,a);if(l instanceof Map)return new Map(r(Array.from(l),a));if(l instanceof Set)return new Set(r(Array.from(l),a));var t={};for(var o in l){var s=l[o];typeof s!="object"||s===null?t[o]=s:s instanceof Date?t[o]=new Date(s):s instanceof Map?t[o]=new Map(r(Array.from(s),a)):s instanceof Set?t[o]=new Set(r(Array.from(s),a)):ArrayBuffer.isView(s)?t[o]=x(s):t[o]=a(s)}return t}}function Le(e){var r=[],n=[];return e.proto?t:l;function a(o,s){for(var u=Object.keys(o),i=new Array(u.length),g=0;g<u.length;g++){var c=u[g],b=o[c];if(typeof b!="object"||b===null)i[c]=b;else if(b instanceof Date)i[c]=new Date(b);else if(ArrayBuffer.isView(b))i[c]=x(b);else{var y=r.indexOf(b);y!==-1?i[c]=n[y]:i[c]=s(b)}}return i}function l(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return a(o,l);if(o instanceof Map)return new Map(a(Array.from(o),l));if(o instanceof Set)return new Set(a(Array.from(o),l));var s={};r.push(o),n.push(s);for(var u in o)if(Object.hasOwnProperty.call(o,u)!==!1){var i=o[u];if(typeof i!="object"||i===null)s[u]=i;else if(i instanceof Date)s[u]=new Date(i);else if(i instanceof Map)s[u]=new Map(a(Array.from(i),l));else if(i instanceof Set)s[u]=new Set(a(Array.from(i),l));else if(ArrayBuffer.isView(i))s[u]=x(i);else{var g=r.indexOf(i);g!==-1?s[u]=n[g]:s[u]=l(i)}}return r.pop(),n.pop(),s}function t(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return a(o,t);if(o instanceof Map)return new Map(a(Array.from(o),t));if(o instanceof Set)return new Set(a(Array.from(o),t));var s={};r.push(o),n.push(s);for(var u in o){var i=o[u];if(typeof i!="object"||i===null)s[u]=i;else if(i instanceof Date)s[u]=new Date(i);else if(i instanceof Map)s[u]=new Map(a(Array.from(i),t));else if(i instanceof Set)s[u]=new Set(a(Array.from(i),t));else if(ArrayBuffer.isView(i))s[u]=x(i);else{var g=r.indexOf(i);g!==-1?s[u]=n[g]:s[u]=t(i)}}return r.pop(),n.pop(),s}}});var Ie=oe((Ee,K)=>{(function(e,r){"use strict";typeof K=="object"&&typeof K.exports=="object"?K.exports=r():typeof define=="function"&&define.amd?define([],r):e.objectPath=r()})(Ee,function(){"use strict";var e=Object.prototype.toString;function r(g,c){return g==null?!1:Object.prototype.hasOwnProperty.call(g,c)}function n(g){if(!g||t(g)&&g.length===0)return!0;if(typeof g!="string"){for(var c in g)if(r(g,c))return!1;return!0}return!1}function a(g){return e.call(g)}function l(g){return typeof g=="object"&&a(g)==="[object Object]"}var t=Array.isArray||function(g){return e.call(g)==="[object Array]"};function o(g){return typeof g=="boolean"||a(g)==="[object Boolean]"}function s(g){var c=parseInt(g);return c.toString()===g?c:g}function u(g){g=g||{};var c=function(d){return Object.keys(c).reduce(function(f,p){return p==="create"||typeof c[p]=="function"&&(f[p]=c[p].bind(c,d)),f},{})},b;g.includeInheritedProps?b=function(){return!0}:b=function(d,f){return typeof f=="number"&&Array.isArray(d)||r(d,f)};function y(d,f){if(b(d,f))return d[f]}var h;g.includeInheritedProps?h=function(d,f){typeof f!="string"&&typeof f!="number"&&(f=String(f));var p=y(d,f);if(f==="__proto__"||f==="prototype"||f==="constructor"&&typeof p=="function")throw new Error("For security reasons, object's magic properties cannot be set");return p}:h=function(d,f){return y(d,f)};function w(d,f,p,m){if(typeof f=="number"&&(f=[f]),!f||f.length===0)return d;if(typeof f=="string")return w(d,f.split(".").map(s),p,m);var $=f[0],T=h(d,$);return f.length===1?((T===void 0||!m)&&(d[$]=p),T):(T===void 0&&(typeof f[1]=="number"?d[$]=[]:d[$]={}),w(d[$],f.slice(1),p,m))}return c.has=function(d,f){if(typeof f=="number"?f=[f]:typeof f=="string"&&(f=f.split(".")),!f||f.length===0)return!!d;for(var p=0;p<f.length;p++){var m=s(f[p]);if(typeof m=="number"&&t(d)&&m<d.length||(g.includeInheritedProps?m in Object(d):r(d,m)))d=d[m];else return!1}return!0},c.ensureExists=function(d,f,p){return w(d,f,p,!0)},c.set=function(d,f,p,m){return w(d,f,p,m)},c.insert=function(d,f,p,m){var $=c.get(d,f);m=~~m,t($)||($=[],c.set(d,f,$)),$.splice(m,0,p)},c.empty=function(d,f){if(!n(f)&&d!=null){var p,m;if(p=c.get(d,f)){if(typeof p=="string")return c.set(d,f,"");if(o(p))return c.set(d,f,!1);if(typeof p=="number")return c.set(d,f,0);if(t(p))p.length=0;else if(l(p))for(m in p)b(p,m)&&delete p[m];else return c.set(d,f,null)}}},c.push=function(d,f){var p=c.get(d,f);t(p)||(p=[],c.set(d,f,p)),p.push.apply(p,Array.prototype.slice.call(arguments,2))},c.coalesce=function(d,f,p){for(var m,$=0,T=f.length;$<T;$++)if((m=c.get(d,f[$]))!==void 0)return m;return p},c.get=function(d,f,p){if(typeof f=="number"&&(f=[f]),!f||f.length===0)return d;if(d==null)return p;if(typeof f=="string")return c.get(d,f.split("."),p);var m=s(f[0]),$=h(d,m);return $===void 0?p:f.length===1?$:c.get(d[m],f.slice(1),p)},c.del=function(f,p){if(typeof p=="number"&&(p=[p]),f==null||n(p))return f;if(typeof p=="string")return c.del(f,p.split("."));var m=s(p[0]);if(h(f,m),!b(f,m))return f;if(p.length===1)t(f)?f.splice(m,1):delete f[m];else return c.del(f[m],p.slice(1));return f},c}var i=u();return i.create=u,i.withInheritedProps=u({includeInheritedProps:!0}),i})});var fr={};Pe(fr,{defaults:()=>Ne,jVar:()=>lr,version:()=>tr});function I(e){return typeof e!="string"?e:e.length?[e]:[]}var ue=J(F(),1);var cr=(0,ue.default)();function E(e){if(e==null||typeof e!="object")return!1;let r=Object.getPrototypeOf(e);return r!==null&&r!==Object.prototype&&Object.getPrototypeOf(r)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function A(e){return typeof e=="string"}function ge(e){return Number.isFinite(e)}function _(e){return Number.isSafeInteger(e)&&e>=0}function L(e){return typeof e=="boolean"}function j(e){return e===null}function W(e){return e!=null}function he(e,r){return E(e)&&A(r)&&r in e}var ce={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},ke=e=>e+1;function qe(e,r,n,a,l=!1,t=ke){let o=typeof n=="function"?n():n;if(+r<0&&l&&o==="EOL")return o;let s=v(v({},ce),a);if(r>=e.length&&!l)return!1;let u=l?1:n.length,i=0,g=!1,c=!1,b=!1,y=s.maxMismatches,h=r,w=!1,d=!1,f=!1;function p(){return i===1&&y<s.maxMismatches-1}for(;e[h];){let m=t(h);if(s.trimBeforeMatching&&e[h].trim()===""){if(!e[m]&&l&&n==="EOL")return!0;h=t(h);continue}if(s&&!s.i&&s.trimCharsBeforeMatching&&s.trimCharsBeforeMatching.includes(e[h])||s!=null&&s.i&&s.trimCharsBeforeMatching&&s.trimCharsBeforeMatching.map(T=>T.toLowerCase()).includes(e[h].toLowerCase())){if(l&&n==="EOL"&&!e[m])return!0;h=t(h);continue}let $=m>h?n[n.length-u]:n[u-1];if(!s.i&&e[h]===$||s.i&&e[h].toLowerCase()===$.toLowerCase()){if(w||(w=!0),b||(b=!0),u===n.length){if(d=!0,y!==s.maxMismatches)return!1}else u===1&&(f=!0);if(u-=1,i++,p())return!1;if(!u)return i!==n.length||y===s.maxMismatches||!g?h:!1}else if(!g&&!i&&(g=!0),s.maxMismatches&&y&&h){y-=1;for(let T=0;T<=y;T++){let S=m>h?n[n.length-u+1+T]:n[u-2-T],z=e[t(h)];if(S&&(!s.i&&e[h]===S||s.i&&e[h].toLowerCase()===S.toLowerCase())&&(!s.firstMustMatch||u!==n.length)){if(i++,p())return!1;u-=2,w=!0;break}else if(z&&S&&(!s.i&&z===S||s.i&&z.toLowerCase()===S.toLowerCase())&&(!s.firstMustMatch||u!==n.length)){if(!i&&!s.hungry)return!1;u-=1,w=!0;break}else if(S===void 0&&y>=0&&w&&(!s.firstMustMatch||d)&&(!s.lastMustMatch||f))return h}w||(c=h)}else return h===0&&u===1&&!s.lastMustMatch&&b?0:!1;if(c!==!1&&c!==h&&(c=!1),u<1)return h;h=t(h)}if(u>0)return l&&o==="EOL"?!0:s&&s.maxMismatches>=u&&b?c||0:!1}function pe(e,r,n,a,l){var g,c;if(E(l)&&he(l,"trimBeforeMatching")&&l&&typeof l.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(l.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let t=v(v({},ce),l);if(typeof t.trimCharsBeforeMatching=="string"&&(t.trimCharsBeforeMatching=I(t.trimCharsBeforeMatching)),t.trimCharsBeforeMatching=t.trimCharsBeforeMatching.map(b=>A(b)?b:String(b)),!A(r)||!r.length)return!1;if(!Number.isInteger(n)||n<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof n}, equal to:
${JSON.stringify(n,null,4)}`);let o,s;if(A(a))o=[a];else if(Array.isArray(a))o=a;else if(!a)o=a;else if(typeof a=="function")o=[],o.push(a);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof a}, equal to:
${JSON.stringify(a,null,4)}`);if(l&&!E(l))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof l}", and equal to:
${JSON.stringify(l,null,4)}`);let u=0,i="";if(t!=null&&t.trimCharsBeforeMatching&&t.trimCharsBeforeMatching.some((b,y)=>b.length>1?(u=y,i=b,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${u} is longer than 1 character, ${i.length} (equals to ${i}). Please split it into separate characters and put into array as separate elements.`);if(!o||!Array.isArray(o)||Array.isArray(o)&&!o.length||Array.isArray(o)&&o.length===1&&A(o[0])&&!o[0].trim()){if(typeof t.cb=="function"){let y,h=n;if((e==="matchLeftIncl"||e==="matchRight")&&(h+=1),e[5]==="L")for(let p=h;p--;){let m=r[p];if((!t.trimBeforeMatching||t.trimBeforeMatching&&m!==void 0&&m.trim())&&(!((g=t.trimCharsBeforeMatching)!=null&&g.length)||m!==void 0&&!t.trimCharsBeforeMatching.includes(m))){y=p;break}}else if(e.startsWith("matchRight"))for(let p=h;p<r.length;p++){let m=r[p];if((!t.trimBeforeMatching||t.trimBeforeMatching&&m.trim())&&(!((c=t.trimCharsBeforeMatching)!=null&&c.length)||!t.trimCharsBeforeMatching.includes(m))){y=p;break}}if(y===void 0)return!1;let w=r[y],d=y+1,f="";return d&&d>0&&(f=r.slice(0,d)),e[5]==="L"||y&&y>0&&(f=r.slice(y)),t.cb(w,f,y)}let b="";throw l||(b=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${b}`)}for(let b=0,y=o.length;b<y;b++){s=typeof o[b]=="function";let h=o[b],w,d,f="",p=n;e==="matchRight"?p+=1:e==="matchLeft"&&(p-=1);let m=qe(r,p,h,t,s,$=>e[5]==="L"?$-1:$+1);if(m&&s&&typeof h=="function"&&h()==="EOL")return h()&&(!t.cb||t.cb(w,f,d))?h():!1;if(Number.isInteger(m)&&(d=e.startsWith("matchLeft")?m-1:m+1,e[5]==="L"?f=r.slice(0,m):f=r.slice(d)),d<0&&(d=void 0),r[d]&&(w=r[d]),Number.isInteger(m)&&(!t.cb||t.cb(w,f,d)))return h}return!1}function R(e,r,n,a){return pe("matchLeftIncl",e,r,n,a)}function D(e,r,n,a){return pe("matchRightIncl",e,r,n,a)}function k(e,r=1){let n="\xA0";function a(t){return Array.from(t).reverse().join("")}function l(t,o,s){let u=s?`
`:"\r",i=s?"\r":`
`;if(!t)return t;let g=0,c=0,b="";for(let y=0,h=t.length;y<h;y++)(t[y]===u||t[y]===i&&t[y-1]!==u)&&c++,`\r
`.includes(t[y])||t[y]===n?(g=0,t[y]===n?b+=t[y]:t[y]===u?c<=o&&(b+=t[y],t[y+1]===i&&(b+=t[y+1],y++)):t[y]===i&&(t==null?void 0:t[y-1])!==u&&c<=o&&(b+=t[y])):(g++,!t[y+1]&&!c&&(b+=" "));return b}if(typeof e=="string"&&e.length){let t=1;typeof+r=="number"&&Number.isInteger(+r)&&+r>=0&&(t=+r);let o="",s="";if(!e.trim())o=e;else if(!e[0].trim()){for(let u=0,i=e.length;u<i;u++)if(e[u].trim()){o=e.slice(0,u);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===n)){for(let u=e.length;u--;)if(e[u].trim()){s=e.slice(u+1);break}}return`${l(o,t,!1)}${e.trim()}${a(l(a(s),t,!0))}`}return e}var Ue={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function V(e,r){if(!Array.isArray(e)||!e.length)return e;let n=v(v({},Ue),r),a,l;if(n.strictlyTwoElementsInRangeArrays&&!e.every((s,u)=>!Array.isArray(s)||s.length!==2?(a=u,l=s.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${a}th range (${JSON.stringify(e[a],null,4)}) has not two but ${l} elements!`);if(!e.every((s,u)=>!Array.isArray(s)||!Number.isInteger(s[0])||s[0]<0||!Number.isInteger(s[1])||s[1]<0?(a=u,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${a}th range (${JSON.stringify(e[a],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,o=0;return Array.from(e).sort((s,u)=>(n.progressFn&&(o+=1,n.progressFn(Math.floor(o*100/t))),s[0]===u[0]?s[1]<u[1]?-1:s[1]>u[1]?1:0:s[0]<u[0]?-1:1))}var de={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Ke(e,r){function n(i){return!!i&&typeof i=="object"&&!Array.isArray(i)}if(!Array.isArray(e)||!e.length)return null;let a;if(r)if(n(r)){if(a=v(v({},de),r),a.progressFn&&n(a.progressFn)&&!Object.keys(a.progressFn).length)a.progressFn=null;else if(a.progressFn&&typeof a.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof a.progressFn}", equal to ${JSON.stringify(a.progressFn,null,4)}`);if(![1,2,"1","2"].includes(a.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof a.mergeType}", equal to ${JSON.stringify(a.mergeType,null,4)}`);if(typeof a.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof a.joinRangesThatTouchEdges}", equal to ${JSON.stringify(a.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r,null,4)} (type ${typeof r})`);else a=v({},de);let l=e.filter(i=>Array.isArray(i)).map(i=>[...i]).filter(i=>i[2]!==void 0||i[0]!==i[1]),t,o,s;a.progressFn?t=V(l,{progressFn:i=>{s=Math.floor(i/5),s!==o&&(o=s,a.progressFn(s))}}):t=V(l);let u=t.length-1;for(let i=u;i>0;i--)a.progressFn&&(s=Math.floor((1-i/u)*78)+21,s!==o&&s>o&&(o=s,a.progressFn(s))),(t[i][0]<=t[i-1][0]||!a.joinRangesThatTouchEdges&&t[i][0]<t[i-1][1]||a.joinRangesThatTouchEdges&&t[i][0]<=t[i-1][1])&&(t[i-1][0]=Math.min(t[i][0],t[i-1][0]),t[i-1][1]=Math.max(t[i][1],t[i-1][1]),t[i][2]!==void 0&&(t[i-1][0]>=t[i][0]||t[i-1][1]<=t[i][1])&&t[i-1][2]!==null&&(t[i][2]===null&&t[i-1][2]!==null?t[i-1][2]=null:t[i-1][2]!=null?+a.mergeType==2&&t[i-1][0]===t[i][0]?t[i-1][2]=t[i][2]:t[i-1][2]+=t[i][2]:t[i-1][2]=t[i][2]),t.splice(i,1),i=t.length);return t.length?t:null}var ze={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},B=class{constructor(e){Q(this,"ranges");Q(this,"opts");let r=v(v({},ze),e);if(r.mergeType&&r.mergeType!==1&&r.mergeType!==2)if(A(r.mergeType)&&r.mergeType.trim()==="1")r.mergeType=1;else if(A(r.mergeType)&&r.mergeType.trim()==="2")r.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof r.mergeType}", equal to ${JSON.stringify(r.mergeType,null,4)}`);this.opts=r,this.ranges=[]}add(e,r,n){var t;if(e==null&&r==null)return;if(W(e)&&!W(r)){if(Array.isArray(e)){if(e.length){if(e.some(o=>Array.isArray(o))){e.forEach(o=>{Array.isArray(o)&&this.add(...o)});return}e.length&&_(+e[0])&&_(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(r,null,0)})`)}else if(!W(e)&&W(r))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(r,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let a=+e,l=+r;if(_(n)&&(n=String(n)),_(a)&&_(l)){if(W(n)&&!A(n)&&!_(n))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof n}, equal to:
${JSON.stringify(n,null,4)}`);if(W(this.ranges)&&Array.isArray(this.last())&&a===this.last()[1]){if(this.last()[1]=l,this.last()[2],this.last()[2]!==null&&W(n)){let o=this.last()[2]&&this.last()[2].length&&(!((t=this.opts)!=null&&t.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${n}`:n;this.opts.limitToBeAddedWhitespace&&(o=k(o,this.opts.limitLinebreaksCount)),A(o)&&!o.length||(this.last()[2]=o)}}else{this.ranges||(this.ranges=[]);let o=n!==void 0&&!(A(n)&&!n.length)?[a,l,n&&this.opts.limitToBeAddedWhitespace?k(n,this.opts.limitLinebreaksCount):n]:[a,l];this.ranges.push(o)}}else throw _(a)&&a>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof a}" equal to: ${JSON.stringify(a,null,4)}`)}push(e,r,n){this.add(e,r,n)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=Ke(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>W(e[2])?[e[0],e[1],k(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&_(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var ye={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function me(e,r){function n(i){return!!i&&typeof i=="object"&&!Array.isArray(i)}if(!Array.isArray(e)||!e.length)return null;let a;if(r)if(n(r)){if(a=v(v({},ye),r),a.progressFn&&n(a.progressFn)&&!Object.keys(a.progressFn).length)a.progressFn=null;else if(a.progressFn&&typeof a.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof a.progressFn}", equal to ${JSON.stringify(a.progressFn,null,4)}`);if(![1,2,"1","2"].includes(a.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof a.mergeType}", equal to ${JSON.stringify(a.mergeType,null,4)}`);if(typeof a.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof a.joinRangesThatTouchEdges}", equal to ${JSON.stringify(a.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r,null,4)} (type ${typeof r})`);else a=v({},ye);let l=e.filter(i=>Array.isArray(i)).map(i=>[...i]).filter(i=>i[2]!==void 0||i[0]!==i[1]),t,o,s;a.progressFn?t=V(l,{progressFn:i=>{s=Math.floor(i/5),s!==o&&(o=s,a.progressFn(s))}}):t=V(l);let u=t.length-1;for(let i=u;i>0;i--)a.progressFn&&(s=Math.floor((1-i/u)*78)+21,s!==o&&s>o&&(o=s,a.progressFn(s))),(t[i][0]<=t[i-1][0]||!a.joinRangesThatTouchEdges&&t[i][0]<t[i-1][1]||a.joinRangesThatTouchEdges&&t[i][0]<=t[i-1][1])&&(t[i-1][0]=Math.min(t[i][0],t[i-1][0]),t[i-1][1]=Math.max(t[i][1],t[i-1][1]),t[i][2]!==void 0&&(t[i-1][0]>=t[i][0]||t[i-1][1]<=t[i][1])&&t[i-1][2]!==null&&(t[i][2]===null&&t[i-1][2]!==null?t[i-1][2]=null:t[i-1][2]!=null?+a.mergeType==2&&t[i-1][0]===t[i][0]?t[i-1][2]=t[i][2]:t[i-1][2]+=t[i][2]:t[i-1][2]=t[i][2]),t.splice(i,1),i=t.length);return t.length?t:null}var Ge=!0,Z="Invariant failed";function we(e,r){if(!e){if(Ge)throw new Error(Z);var n=typeof r=="function"?r():r,a=n?"".concat(Z,": ").concat(n):Z;throw new Error(a)}}function C(e,r,n){let a=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(r&&!Array.isArray(r))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r,null,4)}`);if(n&&typeof n!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(!(r!=null&&r.filter(g=>g).length))return e;let t;Array.isArray(r)&&Number.isInteger(r[0])&&Number.isInteger(r[1])?t=[Array.from(r)]:t=Array.from(r);let o=t.length,s=0;t.filter(g=>g).forEach((g,c)=>{if(n&&(a=Math.floor(s/o*10),a!==l&&(l=a,n(a))),!Array.isArray(g))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${c}th element not an array: ${JSON.stringify(g,null,4)}, which is ${typeof g}`);if(!Number.isInteger(g[0])){if(!Number.isInteger(+g[0])||+g[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${c}th element, array ${JSON.stringify(g,null,0)}. Its first element is not an integer, string index, but ${typeof g[0]}, equal to: ${JSON.stringify(g[0],null,4)}.`);t[c][0]=+t[c][0]}if(!Number.isInteger(g[1])){if(!Number.isInteger(+g[1])||+g[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${c}th element, array ${JSON.stringify(g,null,0)}. Its second element is not an integer, string index, but ${typeof g[1]}, equal to: ${JSON.stringify(g[1],null,4)}.`);t[c][1]=+t[c][1]}s+=1});let u=me(t,{progressFn:g=>{n&&(a=10+Math.floor(g/10),a!==l&&(l=a,n(a)))}});we(u);let i=u.length;if(i>0){let g=e.slice(u[i-1][1]);e=u.reduce((c,b,y,h)=>{n&&(a=20+Math.floor(y/i*80),a!==l&&(l=a,n(a)));let w=y===0?0:h[y-1][1],d=h[y][0];return`${c}${e.slice(w,d)}${h[y][2]||""}`},""),e+=g}return e}var Qe={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function P(e,r){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let n=v(v({},Qe),r);function a(o){return n.classicTrim&&!o.trim()||!n.classicTrim&&(n.space&&o===" "||n.cr&&o==="\r"||n.lf&&o===`
`||n.tab&&o==="	"||n.nbsp&&o==="\xA0")}let l,t;if(e.length){if(a(e[0]))for(let o=0,s=e.length;o<s;o++){if(!a(e[o])){l=o;break}if(o===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(a(e[e.length-1])){for(let o=e.length;o--;)if(!a(e[o])){t=o+1;break}}return l?t?{res:e.slice(l,t),ranges:[[0,l],[t,e.length]]}:{res:e.slice(l),ranges:[[0,l]]}:t?{res:e.slice(0,t),ranges:[[t,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var Ze={heads:["{{"],tails:["}}"]};function be(e,r){let n=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(r&&!E(r))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof r}!`);let a=v({},r);if(a&&n.call(a,"heads"))if(I(a.heads).every(w=>typeof w=="string"||Array.isArray(w)))typeof a.heads=="string"&&(a.heads=I(a.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(a&&n.call(a,"tails"))if(I(a.tails).every(w=>typeof w=="string"||Array.isArray(w)))typeof a.tails=="string"&&(a.tails=I(a.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let l=P(e).res;if(l.length===0)return e;e=l;let t=v(v({},Ze),a);t.heads=t.heads.map(w=>w.trim()),t.tails=t.tails.map(w=>w.trim());let o=!1,s=!1,u=new B({limitToBeAddedWhitespace:!0}),i=new B({limitToBeAddedWhitespace:!0}),g=!0,c=!0,b="";function y(w,d){let f;return D(w,0,d.heads,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=$,!0)})&&D(w,f,d.tails,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=$,!0)})?w.slice(f):w}for(;e!==y(e,t);)e=P(y(e,t)).res;function h(w,d){let f;return!R(w,w.length-1,d.tails,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=$,!0)})||!f?w:R(w,f,d.heads,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=$,!0)})?w.slice(0,f+1):w}for(;e!==h(e,t);)e=P(h(e,t)).res;if(!t.heads.length||!D(e,0,t.heads,{trimBeforeMatching:!0})||!t.tails.length||!R(e,e.length-1,t.tails,{trimBeforeMatching:!0}))return P(e).res;for(let w=0,d=e.length;w<d;w++)if(e[w].trim()!==""){let f;if(D(e,w,t.heads,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=$,!0)})&&f){c=!0,g&&(g=!0);let p;D(e,f,t.tails,{trimBeforeMatching:!0,cb:(m,$,T)=>(p=T,!0)})&&u.push(w,p),i.current()&&o&&b!=="tails"&&u.push(i.current()),o||i.current()&&(u.push(i.current()),i.wipe()),i.push(w,f),b="heads",w=f-1;continue}if(D(e,w,t.tails,{trimBeforeMatching:!0,cb:(p,m,$)=>(f=Number.isInteger($)?$:e.length,!0)})&&f){c=!0,g?(b==="heads"&&i.wipe(),g=!1):i.push(w,f),b="tails",w=f-1;continue}g&&(g=!0),c&&!o?(o=!0,c=!1):c&&!s?(s=!0,g=!0,c=!1,b==="heads"&&i.wipe()):c&&s&&i.wipe()}return i.current()&&u.push(i.current()),u.current()?C(e,u.current()).trim():e.trim()}var $e={fromIndex:0,throwWhenSomethingWrongIsDetected:!0,allowWholeValueToBeOnlyHeadsOrTails:!0,source:"string-find-heads-tails",matchHeadsAndTailsStrictlyInPairsByTheirOrder:!1,relaxedAPI:!1};function Y(e,r,n,a){if(W(a)&&!E(a))throw new TypeError(`string-find-heads-tails: [THROW_ID_01] the fourth input argument, an Optional Options Object, must be a plain object! Currently it's equal to: ${a} (type: ${typeof a})`);let l=v(v({},$e),a);if(A(l.fromIndex)&&/^\d*$/.test(l.fromIndex))l.fromIndex=Number(l.fromIndex);else if(!Number.isInteger(l.fromIndex)||l.fromIndex<0)throw new TypeError(`${l.source} [THROW_ID_18] the fourth input argument must be a natural number or zero! Currently it's: ${l.fromIndex}`);if(!A(e)||e.length===0){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_02] the first input argument, input string, must be a non-zero-length string! Currently it's: ${typeof e}, equal to: ${e}`)}let t,o;if(!A(r)&&!Array.isArray(r)){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_03] the second input argument, heads, must be either a string or an array of strings! Currently it's: ${typeof r}, equal to:
${JSON.stringify(r,null,4)}`)}else if(A(r))if(r.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_04] the second input argument, heads, must be a non-empty string! Currently it's empty.")}else r=I(r);else if(Array.isArray(r))if(r.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_05] the second input argument, heads, must be a non-empty array and contain at least one string! Currently it's empty.")}else if(r.every((h,w)=>(t=h,o=w,A(h)))){if(!r.every((h,w)=>(o=w,A(h)&&h.length&&h.trim()!=="")))if(l.relaxedAPI){if(r=r.filter(h=>A(h)&&h.length),r.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_07] the second input argument, heads, should not contain empty strings! For example, there's one detected at index ${o} of heads array:
${JSON.stringify(r,null,4)}.`)}else if(l.relaxedAPI){if(r=r.filter(h=>A(h)&&h.length),r.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_06] the second input argument, heads, contains non-string elements! For example, element at ${o}th index is ${typeof t}, equal to:
${JSON.stringify(t,null,4)}. Whole heads array looks like:
${JSON.stringify(r,null,4)}`);if(!A(n)&&!Array.isArray(n)){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_08] the third input argument, tails, must be either a string or an array of strings! Currently it's: ${typeof n}, equal to:
${JSON.stringify(n,null,4)}`)}else if(A(n))if(n.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_09] the third input argument, tails, must be a non-empty string! Currently it's empty.")}else n=I(n);else if(Array.isArray(n))if(n.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_10] the third input argument, tails, must be a non-empty array and contain at least one string! Currently it's empty.")}else if(n.every((h,w)=>(t=h,o=w,A(h)))){if(!n.every((h,w)=>(o=w,A(h)&&h.length&&h.trim()!=="")))if(l.relaxedAPI){if(n=n.filter(h=>A(h)&&h.length),n.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_12] the third input argument, tails, should not contain empty strings! For example, there's one detected at index ${o}. Whole tails array is equal to:
${JSON.stringify(n,null,4)}`)}else if(l.relaxedAPI){if(n=n.filter(h=>A(h)&&h.length),n.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_11] the third input argument, tails, contains non-string elements! For example, element at ${o}th index is ${typeof t}, equal to:
${JSON.stringify(t,null,4)}. Whole tails array is equal to:
${JSON.stringify(n,null,4)}`);let s=l.source===$e.source;if(l.throwWhenSomethingWrongIsDetected&&!l.allowWholeValueToBeOnlyHeadsOrTails){if(I(r).includes(e))throw new Error(`${l.source}${s?": [THROW_ID_16]":""} the whole input string can't be equal to ${A(r)?"":"one of "}heads (${e})!`);if(I(n).includes(e))throw new Error(`${l.source}${s?": [THROW_ID_17]":""} the whole input string can't be equal to ${A(n)?"":"one of "}tails (${e})!`)}let u=r.concat(n).map(h=>h.charAt(0)).reduce((h,w)=>w.charCodeAt(0)>h[1]?[h[0],w.charCodeAt(0)]:w.charCodeAt(0)<h[0]?[w.charCodeAt(0),h[1]]:h,[r[0].charCodeAt(0),r[0].charCodeAt(0)]),i=[],g=!1,c={},b="",y;for(let h=l.fromIndex,w=e.length;h<w;h++){let d=e[h].charCodeAt(0);if(d<=u[1]&&d>=u[0]){let f=D(e,h,r);if(f&&l.matchHeadsAndTailsStrictlyInPairsByTheirOrder){for(let m=r.length;m--;)if(r[m]===f){y=m;break}}if(A(f))if(g){if(l.throwWhenSomethingWrongIsDetected)throw new TypeError(`${l.source}${s?": [THROW_ID_19]":""} When processing "${e}", we found heads (${e.slice(h,h+f.length)}) starting at character with index number "${h}" and there was another set of heads before it! Generally speaking, there should be "heads-tails-heads-tails", not "heads-heads-tails"!
We're talking about the area of the code:


--------------------------------------starts
${e.slice(Math.max(h-200,0),h)}
      \x1B[33m------->\x1B[39m ${`\x1B[31m${e.slice(h,h+f.length)}\x1B[39m`} \x1B[33m<-------\x1B[39m
${e.slice(h+f.length,Math.min(w,h+200))}
--------------------------------------ends


To turn off this error being thrown, set resolvedOpts.throwWhenSomethingWrongIsDetected to Boolean false.`)}else{c={},c.headsStartAt=h,c.headsEndAt=h+f.length,g=!0,h+=f.length-1,b&&(b="");continue}let p=D(e,h,n);if(g&&p&&l.matchHeadsAndTailsStrictlyInPairsByTheirOrder&&y!==void 0&&n[y]!==void 0&&n[y]!==p){let m;for(let $=n.length;$--;)if(n[$]===p){m=$;break}throw new TypeError(`${l.source}${s?": [THROW_ID_20]":""} When processing "${e}", we had "resolvedOpts.matchHeadsAndTailsStrictlyInPairsByTheirOrder" on. We found heads (${r[y]}) but the tails the followed it were not of the same index, ${y} (${n[y]}) but ${m} (${p}).`)}if(A(p))if(g){c.tailsStartAt=h,c.tailsEndAt=h+p.length,i.push(c),c={},g=!1,h+=p.length-1;continue}else l.throwWhenSomethingWrongIsDetected&&(b=`${l.source}${s?": [THROW_ID_21]":""} When processing "${e}", we found tails (${e.slice(h,h+p.length)}) starting at character with index number "${h}" but there were no heads preceding it. That's very naughty!`)}if(l.throwWhenSomethingWrongIsDetected&&h===w-1){if(Object.keys(c).length!==0)throw new TypeError(`${l.source}${s?": [THROW_ID_22]":""} When processing "${e}", we reached the end of the string and yet didn't find any tails (${JSON.stringify(n,null,4)}) to match the last detected heads (${e.slice(c.headsStartAt,c.headsEndAt)})!`);if(b)throw new Error(b)}}return i}var Ae=J(F(),1);function Ye(e){if(e.includes(".")){let r=e.lastIndexOf(".");if(!e.slice(0,r).includes("."))return e.slice(0,r);for(let n=r-1;n--;)if(e[n]===".")return e.slice(n+1,r)}return null}var X=Ye;var ee=(0,Ae.default)();function q(e,r){let n={now:!1};function a(l,t,o,s){let u=ee(l),i,g=v({depth:-1,path:""},o);if(g.depth+=1,Array.isArray(u))for(let c=0,b=u.length;c<b&&!s.now;c++){let y=g.path?`${g.path}.${c}`:`${c}`;u[c]!==void 0?(g.parent=ee(u),g.parentType="array",g.parentKey=X(y),i=a(t(u[c],void 0,H(v({},g),{path:y}),s),t,H(v({},g),{path:y}),s),Number.isNaN(i)&&c<u.length?(u.splice(c,1),c-=1):u[c]=i):u.splice(c,1)}else if(E(u))for(let c in u){if(s.now&&c!=null)break;let b=g.path?`${g.path}.${c}`:c;g.depth===0&&c!=null&&(g.topmostKey=c),g.parent=ee(u),g.parentType="object",g.parentKey=X(b),i=a(t(c,u[c],H(v({},g),{path:b}),s),t,H(v({},g),{path:b}),s),Number.isNaN(i)?delete u[c]:u[c]=i}return u}return a(e,r,{},n)}function re(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var te=new Map,ve=(e,r)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${r}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(n=>{if(typeof n!="string"){if(typeof n>"u")return!1;throw new TypeError(`Expected '${r}' to be an array of strings, but found a type of '${typeof n}' in the array`)}return!0})},Xe=(e,r)=>{r=v({caseSensitive:!1},r);let n=e+JSON.stringify(r);if(te.has(n))return te.get(n);let a=e[0]==="!";a&&(e=e.slice(1)),e=re(e).replace(/\\\*/g,"[\\s\\S]*");let l=new RegExp(`^${e}$`,r.caseSensitive?"":"i");return l.negated=a,te.set(n,l),l},er=(e,r,n,a)=>{if(e=ve(e,"inputs"),r=ve(r,"patterns"),r.length===0)return[];r=r.map(o=>Xe(o,n));let{allPatterns:l}=n||{},t=[];for(let o of e){let s,u=[...r].fill(!1);for(let[i,g]of r.entries())if(g.test(o)&&(u[i]=!0,s=!g.negated,!s))break;if(!(s===!1||s===void 0&&r.some(i=>!i.negated)||l&&u.some((i,g)=>!i&&!r[g].negated))&&(t.push(o),a))break}return t};function U(e,r,n){return er(e,r,n,!0).length>0}var Oe=J(F(),1);var Te=(0,Oe.default)();function ne(e,r,n){let a;n!==void 0&&(a=Array.isArray(n)?Te(n):[Te(n)]);let l=[],t=q(e,(o,s,u)=>{let i=s!==void 0?s:o;if(s!==void 0&&U(o,r,{caseSensitive:!0})){if(a===void 0)l.push({val:s,path:u.path});else if(a.length)return a.shift()}return i});return a===void 0?l:t}var N=J(Ie(),1);var Se="12.0.13";var tr=Se,nr=Object.prototype.hasOwnProperty,Ne={heads:"%%_",tails:"_%%",headsNoWrap:"%%-",tailsNoWrap:"-%%",lookForDataContainers:!0,dataContainerIdentifierTails:"_data",wrapHeadsWith:"",wrapTailsWith:"",dontWrapVars:[],preventDoubleWrapping:!0,wrapGlobalFlipSwitch:!0,noSingleMarkers:!1,resolveToBoolIfAnyValuesContainBool:!0,resolveToFalseIfAnyValuesContainBool:!0,throwWhenNonStringInsertedInString:!1,allowUnresolved:!1};function O(e){return A(e)?e.trim():e}function ir(e){if(A(e)&&e.length&&e.indexOf(".")!==-1){for(let r=0,n=e.length;r<n;r++)if(e[r]===".")return e.slice(0,r)}return e}function sr(e){if(A(e)&&e.length&&e.indexOf(".")!==-1){for(let r=0,n=e.length;r<n;r++)if(e[r]===".")return e.slice(r+1)}return e}function _e(e){if(A(e)&&e.length&&e.indexOf(".")!==-1){for(let r=e.length;r--;)if(e[r]===".")return e.slice(0,r)}return e}function We(e){if(A(e)&&e.length&&e.indexOf(".")!==-1){for(let r=e.length;r--;)if(e[r]===".")return e.slice(r+1)}return e}function ie(e,r){return!A(e)||!e.trim()?!1:!!(e.includes(r.heads)||e.includes(r.tails)||A(r.headsNoWrap)&&r.headsNoWrap.length&&e.includes(r.headsNoWrap)||A(r.tailsNoWrap)&&r.tailsNoWrap.length&&e.includes(r.tailsNoWrap))}function ar(e,r,n){let a,l;return A(e)&&e.length&&D(e,0,r,{trimBeforeMatching:!0,cb:(t,o,s)=>(a=s,!0)})&&R(e,e.length-1,n,{trimBeforeMatching:!0,cb:(t,o,s)=>(l=(s||0)+1,!0)})?e.slice(a,l):e}function De(e,r,n=!1,a,l,t){if(r.wrapHeadsWith||(r.wrapHeadsWith=""),r.wrapTailsWith||(r.wrapTailsWith=""),A(e)&&!n&&r.wrapGlobalFlipSwitch&&!r.dontWrapVars.some(o=>U(t,o))&&(!r.preventDoubleWrapping||r.preventDoubleWrapping&&A(e)&&!e.includes(r.wrapHeadsWith)&&!e.includes(r.wrapTailsWith)))return`${r.wrapHeadsWith}${e}${r.wrapTailsWith}`;if(n){if(!A(e))return e;let o=be(e,{heads:r.wrapHeadsWith,tails:r.wrapTailsWith});return A(o)?ar(o,r.wrapHeadsWith,r.wrapTailsWith):o}return e}function or(e,r,n,a){let l;if(n.indexOf(".")!==-1){let t=n,o=!0;if(a.lookForDataContainers&&A(a.dataContainerIdentifierTails)&&a.dataContainerIdentifierTails.length&&!t.endsWith(a.dataContainerIdentifierTails)){let s=N.default.get(e,t+a.dataContainerIdentifierTails);E(s)&&N.default.get(s,r)&&(l=N.default.get(s,r),o=!1)}for(;o&&t.indexOf(".")!==-1;){if(t=_e(t),We(t)===r)throw new Error(`json-variables/findValues(): [THROW_ID_20] While trying to resolve: "${r}" at path "${n}", we encountered a closed loop. The parent key "${We(t)}" is called the same as the variable "${r}" we're looking for.`);if(a.lookForDataContainers&&A(a.dataContainerIdentifierTails)&&a.dataContainerIdentifierTails.length&&!t.endsWith(a.dataContainerIdentifierTails)){let s=N.default.get(e,t+a.dataContainerIdentifierTails);E(s)&&N.default.get(s,r)&&(l=N.default.get(s,r),o=!1)}if(l===void 0){let s=N.default.get(e,t);E(s)&&N.default.get(s,r)&&(l=N.default.get(s,r),o=!1)}}}if(l===void 0){let t=N.default.get(e,r);t!==void 0&&(l=t)}if(l===void 0)if(r.indexOf(".")===-1){let t=ne(e,r);if(t.length){for(let o=0,s=t.length;o<s;o++)if(A(t[o].val)||L(t[o].val)||j(t[o].val)){l=t[o].val;break}else if(ge(t[o].val)){l=String(t[o].val);break}else if(Array.isArray(t[o].val)){l=t[o].val.join("");break}}}else{let t=ne(e,ir(r));if(t.length)for(let o=0,s=t.length;o<s;o++){let u=N.default.get(t[o].val,sr(r));u&&A(u)&&(l=u)}}return l}function xe(e,r,n,a,l=[]){if(l.includes(n)){let y="";if(l.length>1){let h=` \u2192
`;y=l.reduce((w,d,f)=>w+(f===0?"":h)+(d===n?"\u{1F4A5} ":"  ")+d,` Here's the path we travelled up until we hit the recursion:

`),y+=`${h}\u{1F4A5} ${n}`}throw new Error(`json-variables/resolveString(): [THROW_ID_19] While trying to resolve: "${r}" at path "${n}", we encountered a closed loop, the key is referencing itself."${y}`)}let t={},o=Array.from(l);o.push(n);let s=new B;function u(y,h,w){for(let d=0,f=y.length;d<f;d++){let p=y[d],m=r.slice(p.headsEndAt,p.tailsStartAt);if(m.length===0)s.push(p.headsStartAt,p.tailsEndAt);else if(nr.call(t,m)&&A(t[m]))s.push(p.headsStartAt,p.tailsEndAt,t[m]);else{let $=or(e,m.trim(),n,a);if($===void 0)if(a.allowUnresolved===!0)$="";else if(A(a.allowUnresolved))$=a.allowUnresolved;else throw new Error(`json-variables/processHeadsAndTails(): [THROW_ID_18] We couldn't find the value to resolve the variable ${r.slice(p.headsEndAt,p.tailsStartAt)}. We're at path: "${n}".`);if(!w&&a.throwWhenNonStringInsertedInString&&!A($))throw new Error(`json-variables/processHeadsAndTails(): [THROW_ID_23] While resolving the variable ${r.slice(p.headsEndAt,p.tailsStartAt)} at path ${n}, it resolved into a non-string value, ${JSON.stringify($,null,4)}. This is happening because options setting "throwWhenNonStringInsertedInString" is active (set to "true").`);if(L($)){if(a.resolveToBoolIfAnyValuesContainBool)return s.wipe(),a.resolveToFalseIfAnyValuesContainBool?!1:$;$=""}else{if(j($)&&w)return s.wipe(),$;Array.isArray($)?$=String($.join("")):j($)?$="":$=String($)}let T=n.includes(".")?`${_e(n)}.${m}`:m;if(ie($,a)){let S=De(xe(e,$,T,a,o),a,h,o,T,m.trim());A(S)&&s.push(p.headsStartAt,p.tailsEndAt,S)}else{t[m]=$;let S=De($,a,h,o,T,m.trim());A(S)&&s.push(p.headsStartAt,p.tailsEndAt,S)}}}}let i;try{i=Y(r,a.heads,a.tails,{source:"",throwWhenSomethingWrongIsDetected:!1})}catch(y){throw new Error(`json-variables/resolveString(): [THROW_ID_17] While trying to resolve string: "${r}" at path ${n}, something wrong with heads and tails was detected! Here's the internal error message:
${y}`)}let g=!1;i.length===1&&C(r,[[i[0].headsStartAt,i[0].tailsEndAt]]).trim()===""&&(g=!0);let c=u(i,!1,g);if(typeof c=="boolean"||c===null)return c;try{i=Y(r,a.headsNoWrap,a.tailsNoWrap,{source:"",throwWhenSomethingWrongIsDetected:!1})}catch(y){throw new Error(`json-variables/resolveString(): [THROW_ID_22] While trying to resolve string: "${r}" at path ${n}, something wrong with no-wrap heads and no-wrap tails was detected! Here's the internal error message:
${y}`)}i.length===1&&C(r,[[i[0].headsStartAt,i[0].tailsEndAt]]).trim()===""&&(g=!0);let b=u(i,!0,g);return L(b)||j(b)?b:s!=null&&s.current()?C(r,s.current()):r}function lr(e,r){if(!arguments.length)throw new Error("json-variables/jVar(): [THROW_ID_01] Alas! Inputs are missing!");if(!E(e))throw new TypeError(`json-variables/jVar(): [THROW_ID_02] Alas! The input must be a plain object! Currently it's: ${Array.isArray(e)?"array":typeof e}`);if(r&&!E(r))throw new TypeError(`json-variables/jVar(): [THROW_ID_03] Alas! An Optional Options Object must be a plain object! Currently it's: ${Array.isArray(r)?"array":typeof r}`);let n=v(v({},Ne),r);n.dontWrapVars?Array.isArray(n.dontWrapVars)||(n.dontWrapVars=I(n.dontWrapVars)):n.dontWrapVars=[];let a,l;if(n.dontWrapVars.length&&!n.dontWrapVars.every((o,s)=>A(o)?!0:(a=o,l=s,!1)))throw new Error(`json-variables/jVar(): [THROW_ID_05] Alas! All variable names set in resolvedOpts.dontWrapVars should be of a string type. Computer detected a value "${a}" at index ${l}, which is not string but ${Array.isArray(a)?"array":typeof a}!`);if(n.heads==="")throw new Error("json-variables/jVar(): [THROW_ID_06] Alas! resolvedOpts.heads are empty!");if(n.tails==="")throw new Error("json-variables/jVar(): [THROW_ID_07] Alas! resolvedOpts.tails are empty!");if(n.lookForDataContainers&&n.dataContainerIdentifierTails==="")throw new Error("json-variables/jVar(): [THROW_ID_08] Alas! resolvedOpts.dataContainerIdentifierTails is empty!");if(n.heads===n.tails)throw new Error("json-variables/jVar(): [THROW_ID_09] Alas! resolvedOpts.heads and resolvedOpts.tails can't be equal!");if(n.heads===n.headsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_10] Alas! resolvedOpts.heads and resolvedOpts.headsNoWrap can't be equal!");if(n.tails===n.tailsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_11] Alas! resolvedOpts.tails and resolvedOpts.tailsNoWrap can't be equal!");if(n.headsNoWrap==="")throw new Error("json-variables/jVar(): [THROW_ID_12] Alas! resolvedOpts.headsNoWrap is an empty string!");if(n.tailsNoWrap==="")throw new Error("json-variables/jVar(): [THROW_ID_13] Alas! resolvedOpts.tailsNoWrap is an empty string!");if(n.headsNoWrap===n.tailsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_14] Alas! resolvedOpts.headsNoWrap and resolvedOpts.tailsNoWrap can't be equal!");let t;return q(e,(o,s,u)=>{if(W(s)&&ie(o,n))throw new Error(`json-variables/jVar(): [THROW_ID_15] Alas! Object keys can't contain variables!
Please check the following key: ${o}`);if(s!==void 0?t=s:t=o,t==="")return t;if(n.heads.length&&O(t)===O(n.heads)||n.tails.length&&O(t)===O(n.tails)||n.headsNoWrap.length&&O(t)===O(n.headsNoWrap)||n.tailsNoWrap.length&&O(t)===O(n.tailsNoWrap)){if(!n.noSingleMarkers)return t;throw new Error(`json-variables/jVar(): [THROW_ID_16] Alas! While processing the input, we stumbled upon ${O(t)} which is equal to ${O(t)===O(n.heads)?"heads":""}${O(t)===O(n.tails)?"tails":""}${A(n.headsNoWrap)&&O(t)===O(n.headsNoWrap)?"headsNoWrap":""}${A(n.tailsNoWrap)&&O(t)===O(n.tailsNoWrap)?"tailsNoWrap":""}. If you wouldn't have set resolvedOpts.noSingleMarkers to "true" this error would not happen and computer would have left the current element (${O(t)}) alone`)}return A(t)&&ie(t,n)?xe(e,t,u.path,n):t})}return Je(fr);})();
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 5.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 9.0.13
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 5.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 7.0.13
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */
/**
 * @name string-find-heads-tails
 * @fileoverview Finds where are arbitrary templating marker heads and tails located
 * @version 6.0.13
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-find-heads-tails/}
 */
/**
 * @name ast-monkey-util
 * @fileoverview Utility library of AST helper functions
 * @version 3.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-monkey-util/}
 */
/**
 * @name ast-monkey-traverse
 * @fileoverview Utility library to traverse AST
 * @version 4.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-monkey-traverse/}
 */
/**
 * @name ast-get-values-by-key
 * @fileoverview Extract values and paths from AST by keys OR set them by keys
 * @version 5.0.13
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-get-values-by-key/}
 */
